/*
	calcul des blobs
	
	cf. http://dept-info.labri.u-bordeaux.fr/%7Eschlick/DOC/is1.html
	
 */

#include <math.h>

// le point generateur
float blobx= 0.f, bloby= 0.f, blobz= 0.f;

// la tension de la surface
float blobp= 1.f;

// fixe le point generateur 
void blob_fixe_generateur(float x, float y, float z)
{
	blobx= x;
	bloby= y;
	blobz= z;
}

void blob_fixe_potentiel(float p)
{
	blobp= p;
}


// calcule la distance du point au generateur
float blob_distance(float x, float y, float z)
{
	float d, dd;
	
	dd= blobx - x;
	d= dd*dd;
	
	dd= bloby - y;
	d+= dd*dd;
	
	dd= blobz - z;
	d+= dd*dd;
	
	return sqrt(d);
}

// determine le potentiel pour une distance
float blob_potentiel(float d)
{
	float t;
	
	t= blobp - 4.f * blobp *d*d;
	return .5f * exp(t);
}

// determine le potentiel pour un point de l'espace
float blob_potentiel_point(float x, float y, float z)
{
	float d;
	
	d= blob_distance(x, y, z);
	return blob_potentiel(d);
}

// 
void blob_affiche(float arete, float pas)
{
	float p[8];
	float x, y, z;
	float dx, dy, dz;
	float px, py, pz;
	float p, pp;
	int i, n;
	
	for(x= -arete; x < arete; x+= pas)
	{
		for(y= -arete; y < arete; y+= pas)
		{
			for(z= -arete; z < arete; z+= pas)
			{
				// calcule la fonction aux somments de la cellule
				i= 0;
				for(dx= 0.f; dx < pas; dx+= pas)
				{
					for(dy= 0.f; dy < pas; dy+= pas)
					{
						for(dz= 0.f; dz < pas; dz+= pas)
						{
							px= x+dx; py= y+dy; pz= z+dz;
							p[i]= blob_potentiel_point(px, py, pz);
							i++;
						}
					}
				}
				
				// verifie l'inclusion de la surface dans la cellule
				n= 0;
				for(i= 0; i < 8; i++)
					if(p[i] >= .5f)
						n++;
				
				if(n > 0 && n < 8)
				{
					// la cellule intersecte la surface, afficher le centre de la cellule 
					glVertex3f(x+ pas/2.f, y+ pas/2.f, z+ pas/2.f);
				}
			}
		}
	}
}
